#property indicator_chart_window

//
//
//
//
//

extern string TimeFrame     = "1440";
extern int    BarForHighLow = 1;
extern int    ExtendBars    = 1;
extern string UniqueID      = "Gann fan1";
extern color  ColorForDown  = Red;
extern color  ColorForUp    = DeepSkyBlue;
extern int    TrendLineStyle = STYLE_SOLID;
int timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   timeFrame = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit()
{
   int lookForLen = StringLen(UniqueID);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string name = ObjectName(i);
      if (StringSubstr(name,0,lookForLen)==UniqueID) ObjectDelete(name);
   }      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start() 
{
   drawFan(UniqueID+timeFrameToString(timeFrame)+":1:",iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),iLow(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,ColorForDown);
   drawFan(UniqueID+timeFrameToString(timeFrame)+":2:",iLow(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow),iHigh(NULL,timeFrame,BarForHighLow),iTime(NULL,timeFrame,BarForHighLow)+ExtendBars*60*timeFrame,ColorForUp);
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void drawFan(string name,double p1, datetime t1, double p2, datetime t2, color DrawColor = Gold, int Width = 1)
{
  // SetTrend(name+"1", 0, t1, p1, t2, p2, DrawColor, Width);
  // SetTrend(name+"2", 0, t1, p1, t2, p1 + (p2 - p1)/2.0, DrawColor, Width);
  // SetTrend(name+"3", 0, t1, p1, t2, p1 + (p2 - p1)/3.0, DrawColor, Width);
     SetTrend(name+"4", 0, t1, p1, t2, p1 + (p2 - p1)/4.0, DrawColor, Width);
     SetTrend(name+"5", 0, t1, p1, t2, p1 + (p2 - p1)/8.0, DrawColor, Width);
  // SetTrend(name+"6", 0, t1, p1, t2, p1 + (p2 - p1)*2.0, DrawColor, Width);
  // SetTrend(name+"7", 0, t1, p1, t2, p1 + (p2 - p1)*3.0, DrawColor, Width);
  // SetTrend(name+"8", 0, t1, p1, t2, p1 + (p2 - p1)*4.0, DrawColor, Width);
  // SetTrend(name+"9", 0, t1, p1, t2, p1 + (p2 - p1)*8.0, DrawColor, Width);
}
void SetTrend(string name, int window, datetime t1, double price1, datetime t2, double price2, color clr = Gold, int width = 1)
{
   ObjectCreate(name, OBJ_TREND, window, t1, price1, t2, price2);
   
   ObjectSet(name, OBJPROP_CORNER, 0);
   ObjectSet(name, OBJPROP_RAY, 1);
   ObjectSet(name, OBJPROP_COLOR, clr);
   
   ObjectSet(name, OBJPROP_WIDTH, width);
   ObjectSet(name, OBJPROP_TIME1, t1);
   ObjectSet(name, OBJPROP_TIME2, t2);
   ObjectSet(name, OBJPROP_PRICE1, price1);
   ObjectSet(name, OBJPROP_PRICE2, price2);
   ObjectSet(name, OBJPROP_STYLE, TrendLineStyle);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

